(* Stichworte: Radiogroup
               Abbrechen
               application.processmessages
               label.transparent
               Berechnung von Summen
               Berechnung von Produkten
*)
unit U1pi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    BRechne: TButton;
    EErgebnis: TEdit;
    EPi: TEdit;
    EAbweichung: TEdit;
    EDurchlaeufe: TEdit;
    EAenderung: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Button2: TButton;
    Loben: TLabel;
    Lmitte: TLabel;
    Lunten: TLabel;
    RadioGroup1: TRadioGroup;
    Lobenoben: TLabel;
    procedure RechneNachLeibniz;
    procedure RechneNachWallis;
    procedure RechneNachMachin;
    procedure RechneNachEuler;
    procedure RechneMonteCarlo;
    procedure RechneQuadratwurzelalg;
    procedure rechnenachspigot;
    procedure sechs_12_24Eck;
    procedure BRechneClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
     abbrechen:boolean;
  public
    { Public-Deklarationen }
  end;

const BCRechne='Rechne';
      BCAbbrechen='Abbrechen';

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure Tform1.RechneNachLeibniz;
(* Die Taylorreihe arctan(x)=Summe(-1)^k*x^(2k+1)/(2k+1) ergibt
   die Leibnizsche Reihe arttan(1)
*)
  var rpi: real;
      iNenner, ivorzeichen, iDurchlaeufe: integer;
begin
  //Anfangswerte
  iNenner:=1;
  ivorzeichen:=1;
  iDurchlaeufe:=0;
  rpi:=0;  //Bei Summe: Anfangswert=Neutrales Element der Addition
  eabweichung.show;
 repeat
    if abbrechen then exit; //globale private Variable
    rpi:=rpi+ivorzeichen/inenner;
    ivorzeichen:=-1*ivorzeichen;
    iNenner:=iNenner+2;
    iDurchlaeufe:=IDurchlaeufe+1;
    EErgebnis.Text:=Format('%10.8f',[4*rpi]);
    EAbweichung.text:='1/'+IntToStr(iNenner);
    EDurchlaeufe.Text:=IntToStr(iDurchlaeufe);
    EAenderung.text:=Format('%10.8f',[1/INenner]);
    application.ProcessMessages; //Nachrichtenschlnge abarbeiten
  until false;
end;

procedure Tform1.RechneNachWallis;
  var rpi,rpialt,aend: real;
      izaehler, iDurchlaeufe: integer;
begin
  //Anfangswerte
  abbrechen:=false;
  iZaehler:=2;
  iDurchlaeufe:=0;
  rpi:=1; //Bei Produkt: Anfangswert=Neutrales Element der Multiplikation
  eabweichung.hide;
 repeat
    if abbrechen then exit; //globale private Variable
    rpialt:=rpi;
    rpi:=rpi*iZaehler*iZaehler/pred(iZaehler)/succ(iZaehler);
    aend:=abs(rpialt-rpi);
    izaehler:=izaehler+2; //2 4 6 8 ...
    iDurchlaeufe:=IDurchlaeufe+1;
    EErgebnis.Text:=Format('%10.8f',[2*rpi]);
    EDurchlaeufe.Text:=IntToStr(iDurchlaeufe);
    EAenderung.text:=Format('%10.8f',[abs(aend)]);
    application.ProcessMessages; //Nachrichtenschlnge abarbeiten
  until false;
end;

procedure Tform1.RechneMonteCarlo;
  var x,y,rpi,rpialt,aend: real;
      iTreffer, iDurchlaeufe: integer;
begin
  //Anfangswerte
  abbrechen:=false;
  iTreffer:=0;
  iDurchlaeufe:=0;
  eabweichung.hide;
 rpi:=0;
 randomize;
 repeat
    if abbrechen then exit; //globale private Variable
    rpialt:=rpi;
    x:=random;
    y:=random;
    iDurchlaeufe:=IDurchlaeufe+1;
    if (x*x+y*y<1) then inc(iTreffer);
    rpi:=itreffer/iDurchlaeufe;
    aend:=abs(rpialt-rpi);
    EErgebnis.Text:=Format('%10.8f',[4*rpi]);
    EDurchlaeufe.Text:=IntToStr(iDurchlaeufe);
    EAenderung.text:=Format('%10.8f',[abs(aend)]);
    application.ProcessMessages; //Nachrichtenschlnge abarbeiten
  until false; //bis abbrechen=true
end;

{>> Start Quell-Text: >>
x# = 1 / 5                      'Startwerte
y# = 1 / 239
vorz = 1

FOR i% = 3 TO 21 STEP 2         'Start der Schleife

  vorz = -1 * vorz              'Vorzeichen umkehren
  x# = x# + vorz / (i% * 5 ^ i%)
  y# = y# + vorz / (i% * 239 ^ i%)
  pi# = 4 * ((4 * x#) - y#)

  PRINT i%                      'Ausgabe vom Schleifenwert
  PRINT "Ergebnis: "; pi#       'Das Ergebnis

NEXT i%                         'Schleifen-Ende}

procedure TForm1.RechneNachMachin;
    var f5, f239, f55, f239239,
         s5,s239,p5,p239: extended;
        i,vz   : integer;
begin
//             1      1        1                1      1          1
// Pi = 16 * ( - - ----- + ----- - ... ) - 4*( --- - ------- + ------- - ... )
//             5    3*5^3   5*5^5              239   3*239^3   5*239^5
//                      s5                                          s239
//                  p5=1/5^n                                       p239=1/239^n
          f5 := 1/5;
          f239 := 1/239;
          f55 := f5*f5;
          f239239 := f239*f239;
  abbrechen:=false;
  i:=1;
  vz := 1;
  s5 := f5;      //=1/5
  s239 := f239;  //=1/239
  p5 := f5;      //=1/5
  p239 := f239;    //=1/239
  eabweichung.hide;
 repeat
    if abbrechen then exit; //globale private Variable
    //Die eigentliche Berechnung: so einfach!
    inc(i,2);              //nchster Wert 3
    vz := -vz;             //              -1
    p5 := p5*f55;          //              1/5^3
    p239 := p239*f239239;  //              1/239^3
    s5 := s5 + vz/i*p5;    //=1/5 - 1/(3*5^3)
    s239 := s239 + vz/i*p239; //anlaog
    //Die Prsentation
    EErgebnis.Text:=Formatfloat('#.##################',16*s5 - 4*s239);
    EDurchlaeufe.Text:=IntToStr(i);
    if abs(4*1/i*p5 + 1/i*p239) < 1E-18 then  Begin
      showmessage('Genauigkeit erreicht!'#13+
      'John Machin errechnete 1706 mit dieser Reihe Pi auf 100 Dezimalen.'#13+
      'Er fand die Reie als Pi = 16*arctan(1/5) - 4*arctan(1/239).'#13+
      'Solche Reihen existieren inzwischen unzhlige.');
      exit;
    End;
    EAenderung.text:=Formatfloat('#.### ### ### ### ### ###',4*1/i*p5 + 1/i*p239);
    application.ProcessMessages; //Nachrichtenschlnge abarbeiten
    sleep(500);
  until false;
end;

procedure TForm1.RechneNachEuler;
    var z, q: extended;
        i   : integer;
begin
  //Pi^2/6=1+1/4+1/9+1/16... nach Euler(???)
  //Anfangswerte
  abbrechen:=false;
  z:=0;
  i:=0;
  eabweichung.show;
 repeat
    if abbrechen then exit; //globale private Variable
    //Die eigentliche Berechnung: so einfach!
    inc(i);
    q:=1.0/i/i;
    z:=z+q;
    //Die Prsentation
    EErgebnis.Text:=Format('%10.8f',[sqrt(6*z)]);
    EDurchlaeufe.Text:=IntToStr(i);
    EAenderung.text:=Format('%10.8f',[q]);
    eabweichung.text:='1/'+intToStr(i*i);
    application.ProcessMessages; //Nachrichtenschlnge abarbeiten
  until false;
end;

function SpigotAnfang(k: integer): extended;
begin
  //result :=1+ 1/3*(1 + 2/5*(1 + 3/7*(1 + 4/9*(1+5/11))));
  {oder
  result := 1;
  result := 1 + 5/11*result;
  result := 1+4/9*result;
  result := 1+3/7*result;
  result := 1+2/5*result;
  result := 1+1/3*result;}
  //Allgemein
  result := 1;
  while k >= 1 do Begin
    result := 1 + k/(2*k+1)*result;
    dec(k);
  End;

end;

(*
Zustzlich ist diese Formel geeignet, Pi aufs Einfachste, d.h.
nur mit ganzen Zahlen, und dazu noch relativ schnell zu berechnen.

Wenn du die Formel also programmieren willst, brauchst du
keine besonderen Bibliotheken zu haben, auch nicht solche fr
"groe Zahlen".

Und relativ schnell heit, schnell genug fr jeden, der nicht
auf Weltrekordjagd geht. Das liegt auch daran, dass man direkt
in der Basis 10 rechnen kann, also keine zeitteuren Konversionen
braucht.

Der besondere Gag ist, dass Ziffer fr Ziffer von Pi
aus dem Algorithmus "trpfelt", der deswegen auch so heit.
Da kann man dann leicht nachvollziehen, was da passiert,
und es ist nicht so wie bei diesen Formel-Boliden, die dich
von 2 auf 100 Stellen in einer Operation bringen (oder so).

In dem Klassiker "The Quest for Pi David H. Bailey", Jonathan M.
Borwein, Peter B. Borwein and Simon Plouffe June, zu erhalten hier
http://citeseer.nj.nec.com/5892.html wird er auf Seite 8 beschrieben.

Eine kleine Bastelanleitung findest du auch auf
http://icg.harvard.edu/~fs5/pi/RTFTechTree/
unter Spigotry.rtf

Und schlielich gibt es hervorragende Implementierungen
im Internet, z.B. in der Sprache 'Java' unter
http://www.luschny.de/math/Pi/pispigot.html

... und dieser Hinweis, so wird jetzt jeder behaupten, war
wohl der einzige Grund, warum ich dir geantwortet habe :-))

Gru Peter

// Purpose: computes the first n decimal digits of Pi
// uses a variant of the spigot algorithm valid for n < 54900
// Author: peter@luschny.de
// Date: 2000-05-16/18:45 (Rev. 0)
// This file was released to the public domain.
// Feel free to use this source code in any way.
// Want no money, no credit, no admiration.

// CREDITS
// based on ideas of A.Sale (1968)
// algorithm due to D.Saada (1988) and S.Rabinowitz (1991)
// proof (with some bugs) due to S.Rabinowitz and S.Wagon (1995)
// C-implementation due to J.Arndt, C.Haenel, D.Winter, A.Flammenkamp
// this Java-implementation adopts and modifies this C-implementation, see page 84 in
// J.Arndt, C. Haenel: Pi - Algorithmen, Computer, Arithmetik
// 2. edition, Springer 2000. Also highly recommended:
// Jean-Paul Delahaye: Pi - die Story, Birkhauser 1999
package de.luschny.math.numbers.pi;*)


procedure Tform1.rechnenachspigot;
  var p:extended;
      k: integer;
begin
  k := 0;
  repeat
    if abbrechen then exit; //globale private Variable
    p := SpigotAnfang(k);
    EErgebnis.Text:=FloatToStr(2*p); //Format('%10.8f',[2*p]);
    EAbweichung.text:='';
    EDurchlaeufe.Text:=intToStr(k);
    sleep(500);
    EAenderung.text:='';
    inc(k);
    application.ProcessMessages; //Nachrichtenschlnge abarbeiten
  until false;

end;

procedure Tform1.RechneQuadratwurzelalg;
  var a,b,aalt:extended;
      p: array[0..5] of extended;
      i:integer;
begin
  a:=sqrt(2); //-0.00000000001 verflscht schon das Ergebnis
  b:=0;//0;
  p[0]:=2+a;
  i:=0;
  repeat
    aalt:=a;
    EDurchlaeufe.Text:=IntToStr(i);
    if abbrechen then exit; //globale private Variable
    a := 1/2*(sqrt(aalt) + 1/sqrt(aalt));
    b := sqrt(aalt)*(b+1)/(b+aalt);
    p[i+1] := p[i]*b*(1+a)/(1+b);
    EAenderung.text:=Format('%10.18f',[p[i+1]-p[i]]);
    EErgebnis.Text:=Format('%10.18f',[p[i]]);
    application.ProcessMessages;
    inc(i);
    sleep(1000);
  until i>5;//Das reicht
    showmessage('Der Algorithmus ist "mrderisch" schnell'#13+
                '  p[0]='+Format('%10.18f',[p[0]])+#13+
                '  p[1]='+Format('%10.18f',[p[1]])+#13+
                '  p[2]='+Format('%10.18f',[p[2]])+#13+
                '  p[3]='+Format('%10.18f',[p[3]])+#13+
                '  p[4]='+Format('%10.18f',[p[4]])+#13+
                '  p[5]='+Format('%10.18f',[p[5]])+#13+
                'Er ist aber nur so genau wie die Anfangswerte'#13+
                '(nicht selbstkorrigierend)');

end;

procedure Tform1.sechs_12_24Eck;
  var u,ualt:extended;
      i,n:integer;
  { '          2         2            2        2',
       'u = 6*r u  = 12*(2*r - r*sqrt(4*r - (u /6) ) ....',
       ' 6       12                           6');
    r=1}
begin
  u:=6;
  i:=6;
  n:=0;
  Label7.caption:='n-Eck n=';
  EAbweichung.hide;
  repeat
    if abbrechen then exit; //globale private Variable
    ualt:=u;
    u:=2*i*sqrt(2-sqrt(4-sqr(u/i)));
    if i>maxint/2 then Begin
      showmessage('Muss abbrechen, da fr n-Eck n zu gross fr den Computer.'#13+
                  'berhaupt summierten sich vorher schon die Fehler, da'#13+
                  'bei Umfang=n*Seitenlnge n zu gro und Seitenlnge zu klein ist.'#13+
                  'Beobachte, was passiert, wenn nderung=0 wird.');
      exit;
    End;
    i:=2*i;
    inc(n);
    EDurchlaeufe.Text:='6*2^'+intToStr(n)+'='+IntToStr(i);
    EAenderung.text:=Format('%10.18f',[(u-ualt)/2]);
    EErgebnis.Text:=Format('%10.18f',[u/2]);
    Case i of  96: showmessage('Archimedes berechnete Pi mit Hilfe des 96-Eckes zu 3''1/7');
              192: showmessage('Liu Hui, China ca. 263 n.Chr.  berechnete Pi mit Hilfe des 192-Eckes zu 3,1415');
             3072: showmessage('Liu Hui, spter dann, berechnete Pi mit Hilfe des 3072-Eckes zu 3,14159'#13+
                               'Von Zu Chong-Zhi (430-501) stammt die auf 6 Dezimalen genaue Nherung 355/113');
        805306368: showmessage('al-Kasi, 1427, Samarkant berechnete Pi mit Hilfe des 805306368-Eckes auf 16 Dezimalstellen.'#13+
                   'Bei unserem Computer hufen sich schon die Rundungsfehler!');
    End;
    application.ProcessMessages;
    sleep(500);
  until false;//Das reicht

end;

procedure TForm1.BRechneClick(Sender: TObject);
begin
  if Brechne.Caption=BCAbbrechen then Begin
     abbrechen:=true;
     BRechne.Caption:=BCrechne
  End else Begin
    BRechne.Caption:=BCAbbrechen;
    abbrechen:=false;
    Label7.caption:='Durchlauf';
    CAse Radiogroup1.ItemIndex of 0:sechs_12_24Eck;
                                  1:RechneNachLeibniz;
                                  2:RechneNachWallis;
                                  3:RechneNachEuler;
                                  4:RechneNachMachin;
                                  5:RechneMonteCarlo;
                                  6:RechneQuadratwurzelalg;
                                  7:RechnenachSpigot;
    ENd;
  End;
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
 abbrechen:=true;
 close;
end;

procedure Lomu(const oo,o,m,u:string);
begin
  with Form1 do Begin
    abbrechen:=true;
    lobenoben.caption:=oo;
    loben.caption:=o;
    lmitte.caption:=m;
    lunten.caption:=u;
  End;
end;


procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
   bRechne.Caption:=BCRechne;
  //Bruchstrich=#151=''
  Case Radiogroup1.itemindex of 0: Lomu('',
       '          2         2            2        2',
       'u = 6*r u  = 12*(2*r - r*sqrt(4*r - (u /6) ) ....',
       ' 6       12                           6');
                                1: Lomu('',
       'Pi       1   1   1   1    1    1    1',
       ' = 1 - - + + - - +  -  +  -  + ...',
       '4        3   7   9   11   13   15   17');
                                2: Lomu('',
       'Pi   2*2 *4*4* 6*6* 8*8* ...',
       ' = ',
       '2    1*3* 3*5* 5*7* 7*9* ...');
                                3: Lomu('2',
       'Pi        1   1   1    1',
       ' = 1 +  +  +  +  + ...',
       '6         4   9   16   25');
                                4: lomu('',
       '          1     1         1                1      1          1',
       'Pi = 16*( - - ------ + ----- - ... ) - 4*(--- - ------- + ------- - ... )',
       '          5    3*5^3   5*5^5              239   3*239^3   5*239^5');
                                5: lomu('',
       'im Quadrat 0<x<1, 0<y<1 wird ausgezhlt,',
       'wie hufig ein zuflliger Punkt(x|y) im Viertelskreis',
       'mit der Gleichung x^2+y^2<1 zu liegen kommt');
                                6: lomu(
       'a[0]=sqrt(2) b[0]=0 pi[0}=2+sqrt(2)',
       '  a[n+1]  = 1/2(sqrt(a[n]) + 1/sqrt(a[n]))',
       '  b[n+1]  = sqrt(a[n])((b[n]+1)/(b[n]+a[n]))',
       '  pi[n+1] = pi[n]b[n+1](1+a[n+1])/(1+b[n+1])');
                                7: LOmu('',
       'Pi       1     2     3     4',
       ' = 1 + -(1 + -(1 + -(1 + -(1+ ... )))',
       '2        3     5     7     9');
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Epi.text:='3,14159265358979323846...';
   RadioGroup1Click(Sender);
   Brechne.Caption:=BCRechne;
end;

end.
